import java.util.Scanner;
import java.util.Vector;

class GuessResponse {
    int guess;
    int numCircles;
    int numSquares;

    GuessResponse(int g, int nc, int ns) {
        this.guess = g;
        this.numCircles = nc;
        this.numSquares = ns;
    }
}

public class GuessingGameII {

    static final int CASE_INSUFFICIENT_INFORMATION = 0;
    static final int CASE_SUFFICIENT_TO_GUESS_SECRET = 1;
    static final int CASE_ONE_ADDITIONAL_GUESS_SUFFICIENT = 2;

    private static int[] solveGuessingGameII(GuessResponse[] rounds) 
    {
        int[] ret = new int[2];

        /* ------------------- INSERT CODE HERE ---------------------
         *
         * Your code should set ret[0] to be one of the three values above (CASE_INSUFFICIENT_INFORMATION,
         * CASE_SUFFICIENT_TO_GUESS_SECRET, CASE_ONE_ADDITIONAL_GUESS_SUFFICIENT).
         *
         * In the first case, ret[1] will be ignored. For the second case, ret[1] should be equal to the
         * secret, and in the third case, it should contain the smallest guess that will be sufficient to 
         * identify the secret.
         */


        /* -------------------- END OF INSERTION --------------------*/

        return ret;
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int numCases = sc.nextInt();

        for(int i = 0; i < numCases; i++) 
        {
            int numRounds = sc.nextInt();

            GuessResponse[] rounds = new GuessResponse[numRounds];

            for(int j = 0; j < numRounds; j++) {
                rounds[j] = new GuessResponse(sc.nextInt(), sc.nextInt(), sc.nextInt());
            }
            int[] ret = solveGuessingGameII(rounds);

            if(ret[0] == CASE_INSUFFICIENT_INFORMATION) {
                System.out.println("There is no guess that can uniquely identify the secret.");
            } else {
                if(ret[0] == CASE_SUFFICIENT_TO_GUESS_SECRET) {
                    System.out.println("The secret is: " + String.format("%04d", ret[1]));
                } else {
                    System.out.println("There is a guess that can uniquely identify the secret: " + String.format("%04d", ret[1]));
                }
            }
        }
    }
}



